//Bayesian Estimation of a version of SW model

var labobs robs pinfobs dy dc dinve dw mc zcap rk k pk c inve y lab pinf w r a b g qs ms spinf sw kp ewma epinfma;

varexo ea eb eg eqs em epinf ew;

parameters curvw cg curvp constelab constepinf constebeta calfa czcap csadjcost ctou csigma chabb ccs cinvs cfc cindw cprobw cindp cprobp csigl clandaw crdpi crpi cry crr crhoa crhoas crhob crhog crhols crhoqs crhoms crhopinf crhow ctrend cmap cmaw cgy;

// fixed parameters
ctou=.025;
clandaw=1.5;
cg=0.18;
curvp=10;
curvw=10;

model(linear); 

#cpie=1+constepinf/100;
#cgamma=1+ctrend/100 ;
#cbeta=1/(1+constebeta/100);
#clandap=cfc;
#cbetabar=cbeta*cgamma^(-csigma);
#cr=cpie/(cbeta*cgamma^(-csigma));
#crk=(cbeta^(-1))*(cgamma^csigma) - (1-ctou);
#cw = (calfa^calfa*(1-calfa)^(1-calfa)/(clandap*crk^calfa))^(1/(1-calfa));
#cikbar=(1-(1-ctou)/cgamma);
#cik=(1-(1-ctou)/cgamma)*cgamma;
#clk=((1-calfa)/calfa)*(crk/cw);
#cky=cfc*(clk)^(calfa-1);
#ciy=cik*cky;
#ccy=1-cg-cik*cky;
#crkky=crk*cky;
#cwhlc=(1/clandaw)*(1-calfa)/calfa*crk*cky/ccy;
#cwly=1-crk*cky;
#conster=(cr-1)*100;


// sticky price - wage economy

	      mc =  calfa*rk+(1-calfa)*(w) - 1*a - 0*(1-calfa)*a ;
	      zcap =  (1/(czcap/(1-czcap)))* rk ;
	      rk =  w+lab-k ;
	      k =  kp(-1)+zcap ;
	      inve = (1/(1+cbetabar*cgamma))* (  inve(-1) + cbetabar*cgamma*inve(1)+(1/(cgamma^2*csadjcost))*pk ) +qs ;
          pk = -r+pinf(1)-0*b +(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*b + (crk/(crk+(1-ctou)))*rk(1) +  ((1-ctou)/(crk+(1-ctou)))*pk(1) ;
	      c = (chabb/cgamma)/(1+chabb/cgamma)*c(-1) + (1/(1+chabb/cgamma))*c(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(lab-lab(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(r-pinf(+1) + 0*b) +b ;
	      y = ccy*c+ciy*inve+g  +  1*crkky*zcap ;
	      y = cfc*( calfa*k+(1-calfa)*lab +a );
	      pinf =  (1/(1+cbetabar*cgamma*cindp)) * ( cbetabar*cgamma*pinf(1) +cindp*pinf(-1) 
               +((1-cprobp)*(1-cbetabar*cgamma*cprobp)/cprobp)/((cfc-1)*curvp+1)*(mc)  )  + spinf ; 
	      w =  (1/(1+cbetabar*cgamma))*w(-1)
               +(cbetabar*cgamma/(1+cbetabar*cgamma))*w(1)
               +(cindw/(1+cbetabar*cgamma))*pinf(-1)
               -(1+cbetabar*cgamma*cindw)/(1+cbetabar*cgamma)*pinf
               +(cbetabar*cgamma)/(1+cbetabar*cgamma)*pinf(1)
               +(1-cprobw)*(1-cbetabar*cgamma*cprobw)/((1+cbetabar*cgamma)*cprobw)*(1/((clandaw-1)*curvw+1))*
               (csigl*lab + (1/(1-chabb/cgamma))*c - ((chabb/cgamma)/(1-chabb/cgamma))*c(-1) -w) 
               + 1*sw ;
	      r =  crpi*(1-crr)*pinf
               +cry*(1-crr)*y     
               +crr*r(-1)
               +ms  ;
	      a = crhoa*a(-1)  + ea;
	      b = crhob*b(-1) + eb;
	      g = crhog*(g(-1)) + eg + cgy*ea;
	      qs = crhoqs*qs(-1) + eqs;
	      ms = crhoms*ms(-1) + em;
	      spinf = crhopinf*spinf(-1) + epinfma - cmap*epinfma(-1);
	          epinfma=epinf;
	      sw = crhow*sw(-1) + ewma - cmaw*ewma(-1) ;
	          ewma=ew; 
	      kp =  (1-cikbar)*kp(-1)+cikbar*inve + cikbar*cgamma^2*csadjcost*qs ;

// measurment equations

dy=y-y(-1)+ctrend;
dc=c-c(-1)+ctrend;
dinve=inve-inve(-1)+ctrend;
dw=w-w(-1)+ctrend;
pinfobs = 1*(pinf) + constepinf;
robs =    1*(r) + conster;
labobs = lab + constelab;

end; 


estimated_params;
stderr ea,INV_GAMMA_PDF,0.45,2;
stderr eb,INV_GAMMA_PDF,0.45,2;
stderr eg,INV_GAMMA_PDF,0.45,2;
stderr eqs,INV_GAMMA_PDF,0.45,2;
stderr em,INV_GAMMA_PDF,0.45,2;
stderr epinf,INV_GAMMA_PDF,0.45,2;
stderr ew,INV_GAMMA_PDF,0.45,2;
crhoa,BETA_PDF,0.5,0.20;
crhob,BETA_PDF,0.5,0.20;
crhog,BETA_PDF,0.5,0.20;
crhoqs,BETA_PDF,0.5,0.20;
crhoms,BETA_PDF,0.5,0.20;
crhopinf,BETA_PDF,0.5,0.20;
crhow,BETA_PDF,0.5,0.20;
cmap,BETA_PDF,0.5,0.2;
cmaw,BETA_PDF,0.5,0.2;
cgy,NORMAL_PDF,0.5,0.2;
csadjcost,NORMAL_PDF,4,1.5;
csigma,NORMAL_PDF,1.50,0.375;
chabb,BETA_PDF,0.7,0.1;
cprobw,BETA_PDF,0.5,0.1;
csigl,NORMAL_PDF,2,0.75;
cprobp,BETA_PDF,0.5,0.10;
cindw,BETA_PDF,0.5,0.15;
cindp,BETA_PDF,0.5,0.15;
czcap,BETA_PDF,0.5,0.15;
cfc,NORMAL_PDF,1.25,0.125;
crpi,NORMAL_PDF,1.5,0.25;
crr,BETA_PDF,0.75,0.10;
cry,NORMAL_PDF,0.125,0.05;
constepinf,GAMMA_PDF,0.625,0.1;
constebeta,GAMMA_PDF,0.25,0.1;
constelab,NORMAL_PDF,0.0,2.0;
ctrend,NORMAL_PDF,0.4,0.10;
calfa,NORMAL_PDF,0.3,0.05;
end;

varobs dc dinve dy labobs pinfobs dw robs;

estimation(
datafile = simdata,
plot_priors=0,
nodiagnostic,
nograph,
bayesian_irf,IRF=15,
mh_replic = 125000,
mh_drop = 0.2,
mh_nblocks = 2,
mh_jscale = 0.375
)
y pinf r
;
